//+------------------------------------------------------------------+
//|                                           i-PassLevCCI_v.1.0.mq4 |
//|                               Gentor,   4 KimIV |
//|                                              http://www.kimiv.ru |
//+------------------------------------------------------------------+
#property copyright "Gentor, KimIV"
#property link      "http://www.kimiv.ru"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 PaleTurquoise
#property indicator_color2 LightSalmon
#property indicator_color3 Red

//-------   ------------------------------------------
extern int CCI_Period   = 14;  //  CCI
extern int NumberOfBars = 0;   //    (0-)
extern int BarsForCheck = 3;   //    

//-------   ------------------------------------------
double SigBuy[];
double SigSell[];
double SigExit[];

//-------   --------------------------------------
bool firstTime = True;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {
  SetIndexBuffer(0, SigBuy);
  SetIndexStyle (0, DRAW_ARROW);
  SetIndexArrow (0, 233);
  SetIndexBuffer(1, SigSell);
  SetIndexStyle (1, DRAW_ARROW);
  SetIndexArrow (1, 234);
  SetIndexBuffer(2, SigExit);
  SetIndexStyle (2, DRAW_ARROW);
  SetIndexArrow (2, 251);
  Comment("");
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() {
  bool fsb=False, fss=False;
  int  loopbegin, shift, cci1, cci2, cci3;

  if (firstTime) {
  	if (NumberOfBars==0) loopbegin = Bars - 1 - CCI_Period;
	  else loopbegin = NumberOfBars - 1;
  }
  if (BarsForCheck<2) BarsForCheck = 2;

  for (shift=loopbegin; shift>=0; shift--) {
    SigBuy[shift] = EMPTY_VALUE;
    SigSell[shift] = EMPTY_VALUE;
    SigExit[shift] = EMPTY_VALUE;
    //   
    cci1 = iCCI(NULL, 0, CCI_Period, PRICE_TYPICAL, shift+1);
    cci2 = iCCI(NULL, 0, CCI_Period, PRICE_TYPICAL, shift+BarsForCheck);
    if (cci1>100 && cci2<-100) {
      SigBuy[shift] = Low[shift] - 10 * Point;
      fsb = True; continue;
    }
    if (cci1<-100 && cci2>100) {
      SigSell[shift] = High[shift] + 10 * Point;
      fss = True; continue;
    }
    //   
    cci3 = iCCI(NULL, 0, CCI_Period, PRICE_TYPICAL, shift+2);
    if (cci1*cci3<0 && (fsb || fss)) {
      SigExit[shift+1] = Close[shift+1];
      fsb = False;
      fss = False;
    }
  }
}
//+------------------------------------------------------------------+

